//
//  GBMiscUtilities.h
//  gBrowser
//
//  Created by Andreas Schwarz on Sun Jan 06 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
// Miscellaneous categories that are too short to waste a whole file with

#import <Cocoa/Cocoa.h>




@interface NSObject (GBTaggableItem)
- (void)setTagged:(BOOL)tagged forTag:(NSString *)tag;
- (void)toggleTag:(NSString *)tag;
- (BOOL)isTaggedWithTag:(NSString *)tag;
- (NSArray *)tags;
@end



@interface NSMutableAttributedString (GBAttributedStringUtilities)

- (NSMutableAttributedString *)truncateForWidth:(float)inWidth;

@end


@interface NSWindow (GBWindowUtilities)
- (NSPoint)currentOrigin;
- (float)titleBarHeight;
@end



@interface NSScrollView (GBScrollViewUtilities)
- (void)offsetX:(NSInteger)x Y:(NSInteger)y;
@end


@interface NSApplication (GBApplicationUtilites)

- (id)betterSearchForTargetForAction:(SEL)action;

@end


@interface NSScreen (GBScreenUtilities)
+ (NSScreen *)menubarScreen;
@end


@interface NSEvent (GBEventUtilities)
+ (BOOL)isControlKeyDown;
+ (BOOL)isOptionKeyDown;
+ (BOOL)isCommandKeyDown;
+ (BOOL)isShiftKeyDown;
+ (NSTimeInterval)doubleClickDelay;
@end



@interface NSDate (GBDateUtilities)
- (NSString *)stringForTimeLeftWithPercentComplete:(double)percent returnSecondsLeft:(NSTimeInterval *)secLeftPtr;
@end


@interface NSArray (GBArrayUtilities)
- (NSUInteger)indexOfObject:(id)anObject inArraySortedUsingSelector:(SEL)selector;
@end


@interface NSMutableArray (GBMutableArrayUtilities)
- (void)insertObject:(id)anObject inArraySortedUsingSelector:(SEL)selector;
- (void)removeObject:(id)anObject fromArraySortedUsingSelector:(SEL)selector;
@end


@interface NSBezierPath (GBBezierPathUtilities)
- (void)strokeInsideWithinRect:(NSRect)rect;
@end


@interface NSAffineTransform (GBAffineTransformOrientationUtilities)
+ (NSAffineTransform *)rotationTransformForOrientation:(NSUInteger)orientation flipped:(BOOL)flipped;
@end


@interface NSOutlineView (GBOutlineViewUtilities)
- (id)selectedItem;
- (NSArray *)allSelectedItems;
- (void)expandAllItems;
- (void)selectItems:(NSArray *)items byExtendingSelection:(BOOL)extend;
@end


@interface NSTimer (GBTimerUtilities)
+ (NSTimer *)scheduledTimerWithTimeInterval:(NSTimeInterval)interval target:(id)target selector:(SEL)selector repeats:(BOOL)repeats retainTarget:(BOOL)retain;
@end

@interface NSNumber (GBNumberUtilities)
- (NSString *)fractionValue;
@end


@interface NSObject (MutableDeepCopy)

- mutableDeepCopy;
- deepCopy;

@end
